<template>
  <v-list-item
    :title="title"
    :density="density"
    :subtitle="subtitle"
    :value="value"
    :lines="lines ? lines : undefined"
  >
    <template v-if="leading !== 'none'" #prepend="{ isActive, isSelected, isIndeterminate, select }">
      <v-list-item-action v-if="leading === 'checkbox'" :start="start">
        <v-checkbox-btn :model-value="isActive"></v-checkbox-btn>
      </v-list-item-action>
      
      <v-list-item-action v-if="leading === 'icon'" :start="start">
        <div>
          <Icon
            height="24"
            width="24"
            :icon="leadingIcon"
            :class="`text-${leadingColor}`"
          />
        </div>
      </v-list-item-action>

      <v-list-item-action v-if="leading === 'switch'" :start="start">
        <svn-pro-switch
          :value="isSelected"
          :color="leadingColor"
        />
      </v-list-item-action>

      <v-list-item-action v-if="leading === 'radio'" :start="start">
        <svn-pro-radio-button
          :value="isSelected"
          :color="leadingColor"
        />
      </v-list-item-action>

      <v-list-item-action v-if="leading === 'avatar'" :start="start">
        <svn-pro-avatar
          :type="leadingMedia ? 'photo' : 'monogram'"
          :image="leadingMedia"
          :firstname="leadingFirstname"
          :size="40"
        />
      </v-list-item-action>

      <v-list-item-action v-if="leading === 'image'" start>
        <v-img
          cover
          :width="56"
          :height="56"
          aspect-ratio="1/1"
          :src="leadingMedia"
          :lazy-src="leadingMedia"
        />
      </v-list-item-action>

      <v-list-item-action v-if="leading === 'video'" start>
        <v-img
          cover
          :width="114"
          :height="64"
          aspect-ratio="16/9"
          :src="leadingMedia"
          :lazy-src="leadingMedia"
        />
      </v-list-item-action>      
    </template>

    <template v-if="trailing !== 'none'" #append="{ isActive, isSelected, isIndeterminate, select }">
      <v-list-item-action v-if="trailing === 'checkbox'" :start="start">
        <v-checkbox-btn :model-value="isActive"></v-checkbox-btn>
      </v-list-item-action>
      
      <v-list-item-action v-if="trailing === 'icon'" :start="start">
        <div>
          <Icon
            height="24"
            width="24"
            :icon="trailingIcon"
            :class="`text-${trailingColor}`"
          />
        </div>
      </v-list-item-action>

      <v-list-item-action v-if="trailing === 'switch'" :start="start">
        <svn-pro-switch
          :value="!isSelected"
          :color="trailingColor"
        />
      </v-list-item-action>

      <v-list-item-action v-if="trailing === 'radio'" :start="start">
        <svn-pro-radio-button
          :value="isSelected"
          :color="trailingColor"
        />
      </v-list-item-action>
    </template>

    <template #title>
      <svn-pro-text body-large regular color="onSurface">
        {{ title }}
      </svn-pro-text>
    </template>
  </v-list-item>
</template>

<script setup>
import { Icon } from "@iconify/vue";
import SvnProText from "../styles/SvnProText.vue";
import SvnProSwitch from "../input/SvnProSwitch.vue";
import SvnProAvatar from "../avatar/SvnProAvatar.vue";
import SvnProCheckbox from "../input/SvnProCheckbox.vue";
import SvnProRadioButton from "../input/SvnProRadioButton.vue";

const props = defineProps({
  title: {
    type: String,
    default: undefined,
  },
  subtitle: {
    type: String,
    default: undefined,
  },
  density: {
    type: String,
    default: 'default',
  },
  minHeight: {
    type: Number,
    default: 56,
  },
  value: {
    type: undefined,
    default: undefined,
  },
  start: {
    type: Boolean,
    default: false,
  },
  lines: [Boolean, String],
  leading: {
    type: String,
    default: 'none',
  },
  trailing: {
    type: String,
    default: 'none',
  },
  leadingIcon: {
    type: String,
    default: 'mingcute:left-line'
  },
  trailingIcon: {
    type: String,
    default: 'mingcute:right-line'
  },
  leadingColor: {
    type: String,
    default: 'primary'
  },
  leadingMedia: {
    type: String,
    default: undefined
  },
  leadingFirstname: {
    type: String,
    default: undefined,
  },
  trailingColor: {
    type: String,
    default: 'primary'
  },
});
</script>